## xpadneo-dkms 0.9.7+git20241224.8d20a23

=== Makefile ===
ETC_PREFIX ?= /etc
DOC_PREFIX ?= /usr/share/doc/xpadneo

MODPROBE_CONFS := xpadneo.conf
UDEV_RULES := 60-xpadneo.rules 70-xpadneo-disable-hidraw.rules
DOC_SRCS := NEWS.md $(wildcard docs/[0-9A-Z]*.md)
DOCS := $(notdir $(DOC_SRCS))

ifeq ($(PREFIX),)
  DKMS ?= dkms
else
  $(warning Installing to prefix, dkms commands will not be run!)
  DKMS ?= : SKIPPING dkms
endif

all: build

help:
	@echo "Targets:"
	@echo "help        This help"
	@echo "build       Prepare the package for DKMS deployment"
	@echo "install     Install the package, documentation and DKMS source code"
	@echo "uninstall   Uninstall the package, documentation and DKMS source code"
	@echo
	@echo "Variables:"
	@echo "PREFIX      Install files into this prefix"
	@echo "DOC_PREFIX  Install doc files relative to the prefix (defaults to /usr/share/doc/xpadneo)"
	@echo "ETC_PREFIX  Install etc files relative to the prefix (defaults to /etc)"
	@echo
	@echo "Using PREFIX requires handling dkms commands in your package script."

.PHONY: build install

.INTERMEDIATE: VERSION

VERSION:
	{ [ -n "$(VERSION)" ] && echo $(VERSION) || git describe --tags --dirty; } >$@

build: VERSION
	$(MAKE) VERSION="$(shell cat VERSION)" -C hid-xpadneo dkms.conf

install: build
	mkdir -p $(PREFIX)$(ETC_PREFIX)/modprobe.d $(PREFIX)$(ETC_PREFIX)/udev/rules.d $(PREFIX)$(DOC_PREFIX)
	install -D -m 0644 -t $(PREFIX)$(ETC_PREFIX)/modprobe.d $(MODPROBE_CONFS:%=hid-xpadneo/etc-modprobe.d/%)
	install -D -m 0644 -t $(PREFIX)$(ETC_PREFIX)/udev/rules.d $(UDEV_RULES:%=hid-xpadneo/etc-udev-rules.d/%)
	install -D -m 0644 -t $(PREFIX)$(DOC_PREFIX) $(DOC_SRCS)
	$(DKMS) add hid-xpadneo

uninstall: VERSION
	$(DKMS) remove "hid-xpadneo/$(shell cat VERSION)" --all
	rm -Rf "$(PREFIX)/usr/src/hid-xpadneo-$(shell cat VERSION)"
	rm -f $(DOCS:%=$(PREFIX)$(DOC_PREFIX)/%)
	rm -f $(UDEV_RULES:%=$(PREFIX)$(ETC_PREFIX)/udev/rules.d/%)
	rm -f $(MODPROBE_CONFS:%=$(PREFIX)$(ETC_PREFIX)/modprobe.d/%)
	rmdir --ignore-fail-on-non-empty -p $(PREFIX)$(ETC_PREFIX)/modprobe.d $(PREFIX)$(ETC_PREFIX)/udev/rules.d $(PREFIX)$(DOC_PREFIX)

=== hid-xpadneo/Makefile ===
KERNEL_SOURCE_DIR ?= /lib/modules/$(shell uname -r)/build
LD := ld.bfd

all: modules

.INTERMEDIATE: ../VERSION

../VERSION:
	$(MAKE) -C .. $(@:../%=%)

# convenience rules for local development

clean modules modules_install: ../VERSION
	$(MAKE) -C $(KERNEL_SOURCE_DIR) INSTALL_MOD_DIR="kernel/drivers/hid" LD=$(LD) M=$(shell pwd)/src VERSION="$(shell cat ../VERSION)" $@

reinstall: modules
	sudo make modules_install
	sudo rmmod hid-xpadneo || true
	sudo modprobe hid-xpadneo $(MOD_PARAMS)

# DKMS support rules

dkms.conf: dkms.conf.in ../VERSION
	sed 's/"@DO_NOT_CHANGE@"/"$(shell cat ../VERSION)"/g' <"$<" >"$@"

=== hid-xpadneo/src/Makefile ===
#
# Makefile for the HID driver
#
ccflags-y += -DVERSION=$(VERSION)
obj-m += hid-xpadneo.o

#FIXME(kakra) Work-around, cleanup after source code split
hid-xpadneo-y += xpadneo.o
$(obj)/xpadneo.c: $(src)/hid-xpadneo.c
	cp $< $@

hid-xpadneo-y += xpadneo/core.o xpadneo/consumer.o xpadneo/keyboard.o

=== misc/examples/c_hidraw/Makefile ===
PROGRAM = hidraw

CFLAGS  += $(shell pkg-config ncurses --cflags)
LDFLAGS += $(shell pkg-config ncurses --libs)

SRC = hidraw.c

OBJ = $(SRC:.c=.o)

.PHONY: all clean

all: $(PROGRAM)

$(PROGRAM): $(OBJ)
	$(CC) $< $(LDFLAGS) -o $@

%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	rm -f $(PROGRAM) $(OBJ)

## xpadneo-dkms 0.9.7%2Bgit20241224.8d20a23

=== debian/control ===
Source: xpadneo-dkms
Section: kernel
Priority: optional
Maintainer: xiangzelong <xiangzelong@deepin.org>
Build-Depends: debhelper-compat (= 13),
               dkms,
               dh-dkms,
Standards-Version: 4.6.2
Homepage: https://github.com/atar-axis/xpadneo

Package: xpadneo-dkms
Architecture: all
Depends: ${misc:Depends}, dkms
Description: Advanced Linux Driver for Xbox One Wireless Controller (shipped with Xbox One S)

## xpadneo-dkms 0.9.7+git20241224.8d20a23

=== debian/changelog ===
xpadneo-dkms (0.9.7+git20241224.8d20a23-0deepin1) unstable; urgency=medium

  * New upstream release.

 -- xiangzelong <xiangzelong@deepin.org>  Thu, 23 Jan 2025 11:02:00 +0800

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with dkms

# 设置模块名称
DKMS_NAME := hid-xpadneo

override_dh_auto_build:
	# DKMS 将处理构建过程，无需在此手动构建
	echo "DKMS 将在安装过程中构建模块。"

override_dh_auto_install:
	# 调用自定义的 install 规则，并传递 PREFIX 和其他变量
	dh_auto_install -- \
		ETC_PREFIX=etc/ \
		DOC_PREFIX=usr/share/doc/xpadneo/ \
		PREFIX=debian/xpadneo-dkms/
	mkdir debian/xpadneo-dkms/usr/lib/
	mv debian/xpadneo-dkms/etc/udev debian/xpadneo-dkms/usr/lib/
	rm -rf debian/xpadneo-dkms/etc/udev

override_dh_dkms:
	dh_dkms -- hid-xpadneo/dkms.conf

## xpadneo-dkms 0.9.8

=== hid-xpadneo/src/Makefile ===
#
# Makefile for the HID driver
#
ccflags-y += -DVERSION=$(VERSION)
obj-m += hid-xpadneo.o

=== debian/changelog ===
xpadneo-dkms (0.9.8-2) unstable; urgency=medium

  * Migrate to gbp workflow.
  * Update Vcs-* fields to point to Salsa.
  * Remove unnecessary Rules-Requires-Root field.
  * Move linux-headers-generic from Recommends to Depends.
  * Update watch file to version 5.
  * Add upstream metadata.
  * Add autopkgtest for DKMS module verification.
  * Add Salsa CI configuration.
  * Use common.postinst instead of dkms add and autoinstaller.
  * Ship upstream config dirs in DKMS source tree for post_install.

 -- Michael Lloyd <michael@micl.dev>  Tue, 24 Feb 2026 12:27:08 +1100

xpadneo-dkms (0.9.8-1) unstable; urgency=medium

  * Initial release. (Closes: #1125989)

 -- Michael Lloyd <michael@micl.dev>  Tue, 20 Jan 2026 15:10:06 +1100

=== debian/control ===
Source: xpadneo-dkms
Section: kernel
Priority: optional
Maintainer: Michael Lloyd <michael@micl.dev>
Build-Depends: debhelper-compat (= 13), dh-dkms
Standards-Version: 4.7.3
Homepage: https://github.com/atar-axis/xpadneo
Vcs-Browser: https://salsa.debian.org/micl/xpadneo-dkms
Vcs-Git: https://salsa.debian.org/micl/xpadneo-dkms.git

Package: xpadneo-dkms
Architecture: all
Depends: ${misc:Depends}, dkms (>= 2.1.0.0), linux-headers-generic
Recommends: bluez (>= 5.48)
Suggests: xserver-xorg-input-joystick
Provides: xpadneo-modules
Description: Advanced Linux driver for Xbox wireless controllers
 This driver supports Xbox wireless controllers via bluetooth, including
 Xbox One, Xbox Series X|S, and Xbox Elite controllers. It provides force
 feedback, rumble, and other advanced features.
 .
 This package uses DKMS to automatically build the hid-xpadneo kernel module.

=== debian/rules ===
#!/usr/bin/make -f

VERSION := $(shell dpkg-parsechangelog -S version | cut -d- -f1)

%:
	dh $@ --with dkms

override_dh_auto_configure:

override_dh_auto_build:

override_dh_auto_test:

override_dh_auto_install:
	install -d debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)
	cp -r hid-xpadneo/src debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	cp hid-xpadneo/Makefile debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	sed 's/@DO_NOT_CHANGE@/$(VERSION)/g' hid-xpadneo/dkms.conf.in \
		> debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/dkms.conf
	install -m 755 hid-xpadneo/dkms.post_install \
		debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	install -m 755 hid-xpadneo/dkms.post_remove \
		debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	cp -r hid-xpadneo/etc-modprobe.d \
		debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	cp -r hid-xpadneo/etc-udev-rules.d \
		debian/xpadneo-dkms/usr/src/hid-xpadneo-$(VERSION)/
	install -d debian/xpadneo-dkms/usr/lib/modprobe.d
	install -m 644 hid-xpadneo/etc-modprobe.d/xpadneo.conf \
		debian/xpadneo-dkms/usr/lib/modprobe.d/
	install -d debian/xpadneo-dkms/usr/lib/udev/rules.d
	install -m 644 hid-xpadneo/etc-udev-rules.d/*.rules \
		debian/xpadneo-dkms/usr/lib/udev/rules.d/

override_dh_installdeb:
	sed 's/@VERSION@/$(VERSION)/g' debian/xpadneo-dkms.preinst.in > debian/xpadneo-dkms.preinst
	sed 's/@VERSION@/$(VERSION)/g' debian/xpadneo-dkms.postinst.in > debian/xpadneo-dkms.postinst
	sed 's/@VERSION@/$(VERSION)/g' debian/xpadneo-dkms.prerm.in > debian/xpadneo-dkms.prerm
	sed 's/@VERSION@/$(VERSION)/g' debian/xpadneo-dkms.postrm.in > debian/xpadneo-dkms.postrm
	dh_installdeb

override_dh_auto_clean:
	rm -f debian/xpadneo-dkms.preinst debian/xpadneo-dkms.postinst debian/xpadneo-dkms.prerm debian/xpadneo-dkms.postrm

=== debian/tests/control ===
Depends: @, dkms
Test-Command: debian/tests/dkms-status
Restrictions: needs-root

=== debian/watch ===
Version: 5

Template: Github
Project: xpadneo
Owner: atar-axis
Dversion-Mangle: auto
